/*
 * The JavaScript for the page "Historikk". Only fetches one data set at a time.
 * Should probably have fetched both at load time (todo). AJAX, JSON and flot.
 */

getConsumptionInformationBarChart(2);
function getConsumptionInformationBarChart(type)
{
var year = new Date().getFullYear();
var startDate = getDate(year);
var stopDate = getDate(year+1);
var monthnames = ["jan", "feb", "mar", "apr", "mai", "jun", "jul", "aug", "sep", "okt", "nov", "des"];
$.ajax({
     type: "POST",
     url: "fetchDataComparePeriods",
     dataType: "json",
     data: "type=" + type,
     success: function(results){
            var d1 = [];
            var d2 = [];
            var d3 = [];
            // dag, uke, måned
            var adjustTimes = [0, 0, 1416960000];
            var stack = 0, bars = true, lines = false, steps = false;
          if(results.length > 0)
          {
            for (var i = 0; i < results.length; i ++){
                if(results[i][2] == year)
                    d3.push([results[i][0] - adjustTimes[type], results[i][1]])
                else if(results[i][2] == year - 1)
                    d2.push([results[i][0] - adjustTimes[type], results[i][1]])
                else if(results[i][2] == year - 2)
                    d1.push([results[i][0] - adjustTimes[type], results[i][1]])
            }
          }
        var content = {label: year-2, color: lightGreen, data: d1};
        var content2 = {label: year-1, color: lightBlue, data: d2};
        var content3 = {label: year, color: lightRed, data: d3};
        var array = new Array(3);
        array.push(content.length);
        var len = findMaxInArray(array);
        changeTimeBGColor(lightGreen, darkGreen, type);
      if(type == 2)
      {
          $.plot($("#placeholder"), [ content, content2, content3 ], {
            series: {
                stack: stack,
                lines: {show: lines, steps: steps},
                bars: {show: bars, barWidth : 10000*60*1000}
            },
            xaxis: {mode: "time", timeformat: "%b", ticks: 12, tickFormatter: function (v, axis) {var d = new Date(v);return '<span style="font-weight: bold; font-size:larger">' + monthnames[d.getUTCMonth()] +" </span>"}},
            yaxis: {tickFormatter: function (v, axis) {return '<span font-size: smaller;">' + v.toFixed(axis.tickDecimals) +" kWh</span>"}}
        });
      }
        else if(type == 1)
        {
            $.plot($("#placeholder"), [ content, content2, content3 ], {
        series: {
            stack: stack,
            lines: {show: lines, steps: steps},
            bars: {show: bars, barWidth : 0.2}
        },
        xaxis: {ticks: 6, tickFormatter: function (v, axis) {return '<span style="font-weight: bold; font-size:larger">Uke ' + Math.floor(v.valueOf()) +" </span>"}},
        yaxis: {tickFormatter: function (v, axis) {return '<span font-size: smaller;">' + v.toFixed(axis.tickDecimals) +" kWh</span>"}}
        });
        }
     },
     error: function(a){
         console.log(a);
     }
});
}
function getDate(year)
{
    var datum = new Date(Date.UTC(year,'00','01','00','00','00'));
    return datum.getTime()/1000;
}

function changeTimeBGColor(baseColor, chosenColor, type){
    $('.hoursRounded').css('background-color', baseColor);
    if(type == 1){
        $('.hoursRounded:even').css('background-color', chosenColor);
    }
    else{
        $('.hoursRounded:last').css('background-color', chosenColor);
    }
}
function findMaxInArray(array)
{
    var max = array[0];
    var len = array.length;
    for (var i = 1; i < len; i++) if (array[i] > max) max = this[i];
    return max;
}