package data;

import java.io.UnsupportedEncodingException;

import crypto.Test;

public class Helper {
	public static byte[] hexStringToByteArray(String s) {
	    int len = s.length();
	    byte[] data = new byte[len / 2];
	    for (int i = 0; i < len; i += 2) {
	        data[i / 2] = (byte) ((Character.digit(s.charAt(i), 16) << 4)
	                             + Character.digit(s.charAt(i+1), 16));
	    }
	    return data;
	}
	public static String getHexString(byte[] raw) 
  {
    byte[] hex = new byte[2 * raw.length];
    int index = 0;

    for (byte b : raw) {
      int v = b & 0xFF;
      hex[index++] = HEX_CHAR_TABLE[v >>> 4];
      hex[index++] = HEX_CHAR_TABLE[v & 0xF];
    }
    try {
		return new String(hex, "ASCII");
	} catch (UnsupportedEncodingException e) {
		e.printStackTrace();
	}
	return "";
  }
	public static final byte[] HEX_CHAR_TABLE = {
	    (byte)'0', (byte)'1', (byte)'2', (byte)'3',
	    (byte)'4', (byte)'5', (byte)'6', (byte)'7',
	    (byte)'8', (byte)'9', (byte)'A', (byte)'B',
	    (byte)'C', (byte)'D', (byte)'E', (byte)'F'
	  };
	public static byte[] intToByteArray(int value) {
        byte[] b = new byte[4];
        for (int i = 0; i < 4; i++) {
            int offset = (b.length - 1 - i) * 8;
            b[i] = (byte) ((value >>> offset) & 0xFF);
        }
        return b;
    }
	public static int stringOfBytesToInt(String number, int offset) {
		byte[] b = Helper.hexStringToByteArray(number);
        int value = 0;
        for (int i = 0; i < 4; i++) {
            int shift = (4 - 1 - i) * 8;
            value += (b[i + offset] & 0x000000FF) << shift;
        }
        return value;
    }
	
	/**
	   * Gets the subarray from <tt>array</tt> that starts at <tt>offset</tt>.
	   */
	  public static byte[] get(byte[] array, int offset) {
	    return get(array, offset, array.length - offset);
	  }

	  /**
	   * Gets the subarray of length <tt>length</tt> from <tt>array</tt>
	   * that starts at <tt>offset</tt>.
	   */
	  public static byte[] get(byte[] array, int offset, int length) {
	    byte[] result = new byte[length];
	    System.arraycopy(array, offset, result, 0, length);
	    return result;
	  }
}
