package dcs;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import data.DB;
import data.Meter;

import net.Client;

public class DataCollector {
	private DB db;
	private HashMap<String, Meter> meters;
	private ArrayList<Client> clients = new ArrayList<Client>();
	private void start()
	{
		db = DB.getDBObject();
		meters = db.getListOfMetersToPoll(true);
		ExecutorService threadExecutor = Executors.newFixedThreadPool(meters.size());
		for (Meter meter : meters.values()) {
			meter.setBeingPolled(true);
			clients.add(new Client(meter));
		}
		while(true)
		{
			checkForMeterChanges();
			for (int j = 0; j < clients.size(); j++) 
			{
				if(clients.get(j).getMeter().isBeingPolled())
				{
					threadExecutor.execute(clients.get(j));
					System.out.println("Started new Client for hostname: " + clients.get(j).getMeter().getIpAddress());
				}
			}
			try{
				Thread.sleep(60000);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
	
	private void checkForMeterChanges() {
		HashMap<String, Meter> map = db.getListOfMetersToPoll(false);
		Meter ex;
		System.out.println(map.size());
		for (Meter meter : map.values()) {
			meter.setBeingPolled(true);
			System.out.println("skjera");
			ex = meters.put(meter.getMacAddress(), meter);
			if(ex == null)
			{
				clients.add(new Client(meter));
			}
			else
			{
				for (Client cl : clients) {
					if(cl.getMeter().getMacAddress().equals(meter.getMacAddress()))
					{
						cl.setMeter(meter);
						break;
					}
				}
			}
		}
	}

	public void clientDied(String hostname)
	{
		meters.get(hostname).setBeingPolled(false);
		System.out.println("Client died: " + meters.get(hostname).getIpAddress());
	}
	
	public static void main(String[] args) {
		DataCollector dc = new DataCollector();
		dc.start();
	}
}
