package test;

import data.MessageTypes;
import data.XMLParser;
import icube.ezhdlc.EzHdlcException;
import icube.ezhdlc.EzHdlcInterface;
import icube.ezhdlc.HDLCParameters;
import icube.ezhdlc.TCPChannelParameters;
import icube.xmlpdu.XmlPduInterface;

public class ReadObjects {
	public static int port = 1025;
	public static String host = "129.241.208.119";
	public static String[] instanceIds = new String[]{
		"00002A0000FF",
		"0101000000FF",
		"0101000001FF",
		"0101000002FF",
		"0101000003FF",
		"010100020180",
		"0101008001FF",
		"0101008201FF",
		"0101008202FF"
	};
	public static void main(String[] args) {
		HDLCParameters params = new HDLCParameters();
		params.ClientMACAddress = (byte) 0x10;
		params.ServerAddressSize = 1;
		params.ServerLowerMACAddressValue = 0;
		params.ServerUpperMACAddressValue = 1;
		params.ResponseTimeout = 3000;
		params.InactivityTimeout = 120000;
		params.InterFrameTimeOut = 500;
		TCPChannelParameters tcpParams = new TCPChannelParameters(host, port);
		byte[] fromServer = new byte[2000];
		byte[] toServer = XMLParser.xmlToPdu(MessageTypes.ASSOCIATION_REQUEST);
		
		try {
			EzHdlcInterface intface = new EzHdlcInterface(params, tcpParams);
			intface.connect();
			fromServer = intface.sendReceive(toServer);
			for (int i = 0; i < instanceIds.length; i++) {
				toServer = XMLParser.xmlToPdu(MessageTypes.getGetRequestNormal("0001", instanceIds[i]));
				fromServer = intface.sendReceive(toServer);
				System.out.println( (i +1 ) + " Got from server: \n" + XMLParser.pduToXml(fromServer));
			}
			intface.disconnect();
		}
		catch (EzHdlcException e) {
			e.printStackTrace();
		}
	}

}
