/*
 * Copyright (c) 1997-2010 EMC Corporation. All rights reserved.
 *
 * This file shall only be used to demonstrate how to interface to an
 * EMC Corporation licensed development product.
 *
 * You have a royalty-free right to use, reproduce and distribute this
 * demonstration file, provided that you agree that EMC Corporation has no
 * warranty, implied or otherwise, or liability for this demonstration file
 * (including any modified version).  This software is provided "as is"
 * without warranties or representations of any kind. EMC Corporation
 * disclaims all conditions and warranties, statutory and otherwise, both
 * express and implied, with respect to the software, its quality and
 * performance, including but not limited to, all implied warranties of
 * merchantability, fitness for a particular purpose, title and
 * noninfringement of third party rights. Without limiting the foregoing,
 * EMC Corporation does not warrant that the software is error-free or that
 * errors in the product will be corrected. You agree that EMC Corporation
 * shall not be liable for any direct, indirect, incidental, special,
 * consequential, punitive or other damages whatsoever resulting from your use
 * of this software or any modified version.
 *
 */
package util;

public class Array {

    public static boolean equals(byte[] array1, int len1, byte[] array2, int len2) {

        if (len1 != len2) {
            return false;
        }

        for (int i=0; i < len1; i++) {
            if (array1[i] != array2[i]) {
                return false;
            }
        }
        return true;
    }

    public static void longToByteArray(long value, byte[] buffer, int offset) {
        buffer[offset + 7] = (byte) value;
        buffer[offset + 6] = (byte) (value >> 8);
        buffer[offset + 5] = (byte) (value >> 16);
        buffer[offset + 4] = (byte) (value >> 24);
        buffer[offset + 3] = (byte) (value >> 32);
        buffer[offset + 2] = (byte) (value >> 40);
        buffer[offset + 1] = (byte) (value >> 48);
        buffer[offset] = (byte) (value >> 56);
    }
}
