package data;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;

import dcs.Meter;

public class DB {
	Connection conn = null;
	private static DB db;
	private String lastUpdatePollTime = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date());
	private DB()
	{
		
	}
	
	public static DB getDBObject()
	{
		if(db == null)
			db = new DB();
		return db;
	}
	
	public void checkConnect()
	{
		if(conn == null)
		{
			connect("ams_web");
		}
	}
	public void connect(String dbName)
    {
        try
        {
//            String userName = "root"; //"ams_web_bruker";
//            String password = "ARjn7WsEC8p78UW9"; //"XdCW69mp9qYm9X7v";
        	String userName = "ams_web_user";
            String password = "vcK4nV5hDWRrGuUy";
//            String url = "jdbc:mysql://localhost/"+dbName;
            String url = "jdbc:mysql://boggle.daling.net/"+dbName;
            Class.forName ("com.mysql.jdbc.Driver").newInstance ();
            conn = DriverManager.getConnection (url, userName, password);
            System.out.println ("Database connection established");
        }
        catch (Exception e)
        {
            System.err.println ("Cannot connect to database server");
            e.printStackTrace();
        }
    }
	
	public HashMap<String, Meter> getListOfMetersToPoll(boolean wholeList)
	{
		HashMap<String, Meter> meters = new HashMap<String, Meter>();
		checkConnect();
		String whereClause = "";
		if(!wholeList) // update meter list
		{
			whereClause = " WHERE time_changed > '" + lastUpdatePollTime + "'";
 		}
		lastUpdatePollTime = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date());
		try {
			Statement stmt = conn.createStatement();
			ResultSet rs = stmt.executeQuery("SELECT mac_address, ip_address, port FROM customer_meter" + whereClause + " ORDER BY time_changed");
			int port = 0;
			while(rs.next())
			{
				port = rs.getInt("port");
				if(port != 0)
					meters.put(rs.getString("mac_address"), new Meter(rs.getString("mac_address"), rs.getString("ip_address"), port));
				else
					meters.put(rs.getString("mac_address"), new Meter(rs.getString("mac_address"),rs.getString("ip_address")));
			}
			stmt.close();
			rs.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return meters;
	}
	
	public void insertMeterData(double meterRecord)
	{
		checkConnect();
		try {
			Statement stmt = conn.createStatement();
			stmt.executeUpdate("INSERT INTO meter_data (customer_id, record) VALUES (1, " + meterRecord + ")");
			stmt.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	public void insertActivePower(double activePower) throws SQLException
	{
		checkConnect();
		Statement stmt = conn.createStatement();
		Statement stmt2 = conn.createStatement();
		ResultSet rs = stmt.executeQuery("SELECT record FROM meter_data WHERE customer_id = 1 ORDER BY time DESC LIMIT 1");
		double current = 0.0;
		if(rs.next())
			current = rs.getDouble("record") + Math.random()*0.5;
		stmt2.executeUpdate("INSERT INTO meter_data (customer_id, record, active_power) VALUES (1, "+ current + ", " + activePower + ")");
		stmt.close();
		stmt2.close();
		rs.close();
	}

	public int getNumberOfMeters() throws SQLException 
	{
		Statement stmt = conn.createStatement();
		ResultSet rs = stmt.executeQuery("SELECT COUNT(*) AS antall FROM customer_meter");
		if(rs.next())
			return rs.getInt("antall");
		rs.close();
		stmt.close();
		return 0;
	}

}
