package data;

import icube.xmlpdu.XmlPduInterface;
import icube.xmlpdu.b.e;

import java.io.IOException;
import java.io.StringReader;
import java.util.ArrayList;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

public class XMLParser {
	
	public static String getRequest= "<GetRequest><GetRequestNormal><InvokeIdAndPriority Value=\"C1\" /><AttributeDescriptor><ClassId Value=\"0007\" /><InstanceId Value=\"0100620200FF\" /><AttributeId Value=\"02\" /></AttributeDescriptor><AccessSelection><AccessSelector Value=\"02\" /><AccessParameters><Structure Qty=\"0004\"><DoubleLongUnsigned Value=\"00000001\" /><DoubleLongUnsigned Value=\"00000001\" /><LongUnsigned Value=\"0001\" /><LongUnsigned Value=\"0001\" /></Structure></AccessParameters></AccessSelection></GetRequestNormal></GetRequest>";
	
	public static void main(String[] args) {
		String xml = "<GetRequest><GetRequestNormal><InvokeIdAndPriority Value=\"C1\" /><AttributeDescriptor><ClassId Value=\"0007\" /><InstanceId Value=\"0100620200FF\" /><AttributeId Value=\"02\" /></AttributeDescriptor><AccessSelection><AccessSelector Value=\"02\" /><AccessParameters><Structure Qty=\"0004\"><DoubleLongUnsigned Value=\"00000001\" /><DoubleLongUnsigned Value=\"00000001\" /><LongUnsigned Value=\"0001\" /><LongUnsigned Value=\"0001\" /></Structure></AccessParameters></AccessSelection></GetRequestNormal></GetRequest>";
		XMLParser p = new XMLParser();
		System.out.println(getSingleValueFromElementName(xml, "InvokeIdAndPriority", "Value"));
		System.out.println(getSingleValueFromElementName(xml, "Structure", "Qty"));
		System.out.println(getChildNodeValues(xml, "Structure"));
	}
	
	public static byte[] xmlToPdu(String xml)
	{
		StringBuffer b = new StringBuffer(xml);
		byte[] pdu = new byte[1];
		try {
			pdu = XmlPduInterface.XmlToPdu(b);
		} catch (e e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return pdu;
	}
	
	public static String pduToXml(byte[] pdu)
	{
		String xml = "";
		try {
			xml = XmlPduInterface.PduToXml(pdu).toString();
		} catch (e e) {
			e.printStackTrace();
		}
		return xml;
	}
	
	public static String getSingleValueFromElementName(String xml, String elementName, String typeOfValue)
	{
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		Document doc;
		String value = "";
		try {
			DocumentBuilder db = dbf.newDocumentBuilder();
			InputSource is = new InputSource();
	        is.setCharacterStream(new StringReader(xml));
			doc = db.parse(is);
			NodeList nodes = doc.getElementsByTagName(elementName);
			Element element = (Element) nodes.item(0);
		    if(element != null && element.getNodeType() == Node.ELEMENT_NODE)
		    {
		    	value = ((Element)element).getAttribute(typeOfValue);
		    }
		}catch(ParserConfigurationException pce) {
			pce.printStackTrace();
		}catch(SAXException se) {
			System.err.println("Bad xml content");
		}catch(IOException ioe) {
			ioe.printStackTrace();
		}
		return value;
	}
	
	
	public static ArrayList<String> getChildNodeValues(String xml, String elementName)
	{
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		Document doc;
		ArrayList<String> values = new ArrayList<String>();
		try {
			DocumentBuilder db = dbf.newDocumentBuilder();
			InputSource is = new InputSource();
	        is.setCharacterStream(new StringReader(xml));
			doc = db.parse(is);
			NodeList nodes = doc.getElementsByTagName(elementName);
			Element element = (Element) nodes.item(0);
		    Node node = element.getFirstChild();
		    String value = "";
		    if(node.getNodeType() == Node.ELEMENT_NODE)
		    {
		       value = ((Element)node).getAttribute("Value");
		       values.add(value);
		    }
			for (int i = 0; i < element.getChildNodes().getLength() - 1; i++) {
			   node = node.getNextSibling();
			   if(node.getNodeType() == Node.ELEMENT_NODE)
			   {
			      value = ((Element)node).getAttribute("Value");
			      values.add(value);
			   }
			}
		}catch(ParserConfigurationException pce) {
			pce.printStackTrace();
		}catch(SAXException se) {
			se.printStackTrace();
		}catch(IOException ioe) {
			ioe.printStackTrace();
		}
		return values;
	}
	
	public static ArrayList<String> getValuesWithElementName(String xml, String elementName)
	{
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		Document doc;
		ArrayList<String> values = new ArrayList<String>();
		try {
			DocumentBuilder db = dbf.newDocumentBuilder();
			InputSource is = new InputSource();
	        is.setCharacterStream(new StringReader(xml));
			doc = db.parse(is);
			NodeList nodes = doc.getElementsByTagName(elementName);
			Node node = (Element)nodes.item(0);
		    String value = "";
		    if(node.getNodeType() == Node.ELEMENT_NODE)
		    {
		       value = ((Element)node).getAttribute("Value");
		       values.add(value);
		    }
			for (int i = 1; i < nodes.getLength() - 1; i++) {
			   node = (Element)nodes.item(i);
			   if(node.getNodeType() == Node.ELEMENT_NODE)
			   {
			      value = ((Element)node).getAttribute("Value");
			      values.add(value);
			   }
			}
		}catch(ParserConfigurationException pce) {
			pce.printStackTrace();
		}catch(SAXException se) {
			se.printStackTrace();
		}catch(IOException ioe) {
			ioe.printStackTrace();
		}
		return values;
	}
}
