package net;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import dcs.Meter;

/*
 * Venter på tilkoblinger fra nettsiden (PHP-socket), for å tillate brukerinitiert
 * henting av aktiv effekt.
 */
public class PollServer implements Runnable {
	public void run() {
		try {
			ServerSocket serverSocket = new ServerSocket(1337);
			Socket clientSocket;
			long lastPollTime = 0;
			int pollDistance = 60000;
			Meter m = new Meter("awer", "strommaler.item.ntnu.no");
			while(true)
			{
				System.out.println("Waiting for connection");
				clientSocket = serverSocket.accept();
				InputStream in = clientSocket.getInputStream();
				BufferedReader br = new BufferedReader(new InputStreamReader(in));
				BufferedWriter out = new BufferedWriter(new OutputStreamWriter(clientSocket.getOutputStream()));
				
			    String request;
	
			    if((request=br.readLine()) != null)
			    {
				    System.out.println("got the following request: " + request);
				    System.out.println("Time gone: " + (System.currentTimeMillis() - lastPollTime));
				    if(request.equals("FetchData") && (System.currentTimeMillis() - lastPollTime) > pollDistance)
				    {
				    	lastPollTime = System.currentTimeMillis();
				    	CustomerClient c = new CustomerClient(m);
				    	c.collectData();
				    	out.write("" + c.getLastActivePower() + "\n");
				    }
				    else{
				    	out.write("NOK" + (60000 - System.currentTimeMillis() + lastPollTime) + "\n");
				    }
				    out.flush();
				    out.close();
				    in.close();
			    }
			}
		}	catch (IOException e) {
			System.err.println("Failed during connection");
			e.printStackTrace();
		}
	}

}
