package test;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.InetAddress;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.ArrayList;

import net.Client;

import crypto.Test;
import data.DB;
import data.HDLCData;
import data.MessageTypes;
import data.XMLParser;
import icube.ezhdlc.EzHdlcException;
import icube.ezhdlc.EzHdlcInterface;
import icube.ezhdlc.HDLCParameters;
import icube.ezhdlc.TCPChannelParameters;
import data.Helper;
import dcs.DataCollector;
import dcs.Meter;

public class WirelessClientTest {
	public static int port = 1025;
	public static String host = "192.168.1.104";
	private Meter meter;
	private InetAddress addr; 
	private OutputStream out;
	private DataOutputStream dos;
	private InputStream in;
	private DataInputStream dis;
	private Socket myClient;
	private DB db;
	private byte[] rawData = new byte[200];
	private byte[] apdu;
	private String activePowerValue = "";
	private int receivedDataLength = 0;
	private static int responseHeaderLength = 11, responseTrailingBytesLength = 3;
	private static int TIME_BETWEEN_POLLS = 12000; //15 * 60000; // 15 min
	private int connectionAttempts = 0;
	
	public WirelessClientTest(Meter m)
	{
		this.meter = m;
	}
	
	public static void main(String[] args) {
		while(true)
		{
		try {
			Meter m = new Meter("aaa", "192.168.1.104");
			WirelessClientTest w = new WirelessClientTest(m);
			w.setUpTCPConnection();
			w.sendAssociationRequest();
			try {
				Thread.sleep(15000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			}catch (Exception e) {
				// TODO: handle exception
			}
		} 
	}
	private void setUpTCPConnection() throws IOException, UnknownHostException
	{
		if(myClient == null || !myClient.isConnected() || myClient.isClosed())
		{
			addr = InetAddress.getByName(meter.getIpAddress());
			myClient = new Socket(addr, meter.getPort());
			out = myClient.getOutputStream();
			in = myClient.getInputStream();
			dos = new DataOutputStream(out);
			dis = new DataInputStream(in);
		}
		
	}
	
	private void sendAssociationRequest() throws IOException
	{
		System.out.println(XMLParser.xmlToPdu(MessageTypes.ASSOCIATION_REQUEST_LOW_SECURITY).length);
		byte[] wpduHeader = new byte[]{
				(byte) 0x00, (byte) 0x01, (byte) 0x00, (byte) 0x11,
				(byte) 0x00, (byte) 0x10, (byte) 0x00, (byte) 0x32
		};
		byte[] wpdu = WirelessClientTest.concat(wpduHeader, XMLParser.xmlToPdu(MessageTypes.ASSOCIATION_REQUEST_LOW_SECURITY));
		dos.write(wpdu, 0, wpdu.length);
		receivedDataLength = dis.read(rawData);
		apdu = new byte[receivedDataLength];
		apdu = Helper.get(rawData, responseHeaderLength, receivedDataLength-responseHeaderLength-responseTrailingBytesLength);
		util.Print.plaintext(apdu);
	}

	private static byte[] concat(byte[] A, byte[] B) {
		   byte[] C = new byte[A.length+B.length];
		   System.arraycopy(A, 0, C, 0, A.length);
		   System.arraycopy(B, 0, C, A.length, B.length);
		   return C;
	}
}
