/*
 * Copyright (c) 1999-2010 EMC Corporation. All rights reserved.
 *
 * This file shall only be used to demonstrate how to interface to an
 * EMC Corporation licensed development product.
 *
 * You have a royalty-free right to use, reproduce and distribute this
 * demonstration file, provided that you agree that EMC Corporation has no
 * warranty, implied or otherwise, or liability for this demonstration file
 * (including any modified version).  This software is provided "as is"
 * without warranties or representations of any kind. EMC Corporation
 * disclaims all conditions and warranties, statutory and otherwise, both
 * express and implied, with respect to the software, its quality and
 * performance, including but not limited to, all implied warranties of
 * merchantability, fitness for a particular purpose, title and
 * noninfringement of third party rights. Without limiting the foregoing,
 * EMC Corporation does not warrant that the software is error-free or that
 * errors in the product will be corrected. You agree that EMC Corporation
 * shall not be liable for any direct, indirect, incidental, special,
 * consequential, punitive or other damages whatsoever resulting from your use
 * of this software or any modified version.
 *
 */
package util;

/**
 * This is the exception thrown by any sample on failure cases.
 */
public class SampleFailedException extends RuntimeException {

    /**
     * Constructs a <code>SampleFailedException</code> object and initializes
     * it with the specified detail message, <em>message</em>.
     *
     * @param message A <code>String</code> that describes the exception.
     */
    public SampleFailedException(String message) {
        super(message);
    }

    /**
     * Constructs a <code>SampleFailedException</code> object and
     * initializes it with the specified exception, <code>e</code>.
     *
     * @param e The nested exception.
     */
    public SampleFailedException(Exception e) {
        super(e);
    }

    /**
     * Constructs a <code>SampleFailedException</code> object and
     * initializes it with the specified detail message, <code>message</code>
     * and exception, <code>e</code>.
     *
     * @param message A <code>String</code> describing the exception.
     * @param e       The nested exception.
     */
    public SampleFailedException(String message, Exception e) {
        super(message, e);
    }
}
